//ce fichier contient de quoi manipuler des matrices 2x2

typedef Complexe nombre;

struct Matrice
{
	nombre m[2][2];
	
	inline void set (Matrice M);
	void unit (); //matrice unité
	bool isunit ();
	bool is_int (); //la matrice n'a-t-elle que des coeffs entiers ?
	Matrice prod (Matrice M);
	Matrice prod (nombre a, nombre b, nombre c, nombre d);
	inline Matrice sub (Matrice M);
	inline Matrice add (Matrice M);
	inline void prod (nombre i); //multiplie à droite par la matrice {{0,1},{1,i}}
	inline void div (nombre i); //divise à droite par la matrice {{0,1},{1,i}}
	//inline void prod (uint i); //multiplie à droite par la matrice {{0,1},{1,i}}
	//inline void div (uint i); //divise à droite par la matrice {{0,1},{1,i}}
//	inline void init1 (ull n); //initialise avec la matrice correspondant à [1,1,...,1] (n fois) (n doit être >= 1)
//	inline void init2 (ull n); //initialise avec la matrice correspondant à [2,2,...,2] (n fois) (n doit être >= 1)
	inline nombre Discr (); //donne le discriminant associé à la matrice
//	inline BigNum BDiscr (); //donne le discriminant associé à la matrice
//	inline void Discr (mpz_t res);
	void disp (); //affiche la matrice
	//void dispc (); //affiche la matrice comme produit de chiffres
	inline nombre Trace ();
	void Transpose ();
	inline void mul (nombre a); //multiplie la matrice par un scalaire
//	uint chiffres (uint *chiffres);
	inline nombre f ();
	inline bool equal (Matrice m);
	void inverse ();
	void inverse2 ();
	nombre Det ();
	//bool M ();
	//uint chiffreg (); //retourne le chiffre de gauche de la matrice (si elle est bien produit de chiffres)
	bool ok (); //détermine si la mtrice doit être dessinée
};

