
struct Complexe
{
	float x,y;
	
	void conj ();
	float cnorm (); //module au carré
	void operator += (Complexe c);
	void operator *= (Complexe c);
	//bool operator == (Complexe c);
	//bool operator == (float x);
	Complexe operator + (Complexe c);
	Complexe operator + (float f);
	Complexe operator - (Complexe c);
	Complexe operator - (float f);
	Complexe operator * (Complexe c);
	Complexe operator * (float f);
	Complexe operator / (Complexe c);
	Complexe operator / (float f);
	void inverse ();
	Complexe homo (Complexe a, Complexe b, Complexe c, Complexe d); //calcule l'homographie (directe)
	Complexe isom_disque (float a, float b, float c, float d); //isométrie du disque donnée par un élément de SL2(R)
	Complexe isom_H2 (float a, float b, float c, float d); //isométrie du demi-plan donnée par un élément de SL2(R)
	Complexe DtoH2 ();
	Complexe H2toD ();
	void disp ();
};

float abs (Complexe c);
Complexe operator- (Complexe c);
bool operator== (Complexe a, Complexe b);
bool operator == (Complexe a, float x);
bool operator == (float x, Complexe a);
Complexe I ();
Complexe r (float f);
